import { defineComponent, $prefix, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/crop/vue";
import { iconConmentRefresh, iconNew, iconZoomIn, iconZoomOut, iconRepeat, iconRefres, iconClose, iconYes, iconCrop } from "@dft-vue-2-opentiny/vue-icon";
import Cropper from "cropperjs";
import "cropperjs/dist/cropper.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dft-vue-2-opentiny/vue-theme/crop/index.css";
var $constants = {
  CROP_IMAGE: "ui.crop.cropImage"
};
var __vue2_script = defineComponent({
  name: $prefix + "Crop",
  components: {
    IconConmentRefresh: iconConmentRefresh(),
    IconNew: iconNew(),
    IconZoomIn: iconZoomIn(),
    IconZoomOut: iconZoomOut(),
    IconRepeat: iconRepeat(),
    IconRefres: iconRefres(),
    IconClose: iconClose(),
    IconYes: iconYes(),
    IconCrop: iconCrop()
  },
  props: {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    alt: {
      type: String,
      default: "image"
    },
    aspectRatio: {
      type: Number,
      default: 16 / 9
    },
    autoCrop: {
      type: Boolean,
      default: true
    },
    autoCropArea: {
      type: Number,
      default: 0.8
    },
    background: {
      type: Boolean,
      default: true
    },
    center: {
      type: Boolean,
      default: false
    },
    cropType: {
      type: String,
      default: "base64"
    },
    cropvisible: {
      type: Boolean,
      default: false
    },
    dragMode: {
      type: String,
      default: "crop"
    },
    guides: {
      type: Boolean,
      default: true
    },
    maxSize: {
      type: String,
      default: "1M"
    },
    minContainerHeight: {
      type: Number,
      default: 300
    },
    minContainerWidth: {
      type: Number,
      default: 652
    },
    minCropBoxHeight: {
      type: Number,
      default: 0
    },
    minCropBoxWidth: {
      type: Number,
      default: 0
    },
    modal: {
      type: Boolean,
      default: true
    },
    movable: {
      type: Boolean,
      default: true
    },
    plugin: {
      type: [Object, Function],
      default: function _default2() {
        return Cropper;
      }
    },
    preview: {
      type: Boolean,
      default: false
    },
    previewShow: {
      type: Boolean,
      default: false
    },
    quality: {
      type: Number,
      default: 0.92,
      validator: function validator(value) {
        return value <= 1 && value > 0;
      }
    },
    rotatable: {
      type: Boolean,
      default: true
    },
    src: {
      type: String,
      default: ""
    },
    viewMode: {
      type: Number,
      default: 0
    },
    wheelZoomRatio: {
      type: Number,
      default: 0.1
    },
    zoomOnWheel: {
      type: Boolean,
      default: true
    },
    zoomable: {
      type: Boolean,
      default: true
    }
  },
  emits: ["update:cropvisible", "update:visible", "ready", "cropstart", "cropmove", "cropend", "crop", "cropdata"],
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-crop__wrapper"
  }, [_vm.preview ? _c("div", {
    staticClass: "tiny-croppreview",
    style: {
      opacity: _vm.state.cropvisible ? 1 : 0
    }
  }, [_vm._m(0), _vm._m(1), _vm._m(2)]) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.cropvisible,
      expression: "state.cropvisible"
    }],
    staticClass: "tiny-crop"
  }, [_c("div", {
    staticClass: "tiny-crop__dialog"
  }, [_c("input", {
    ref: "cropInput",
    attrs: {
      "type": "file",
      "name": "image",
      "accept": "image/*"
    },
    on: {
      "change": _vm.setImage
    }
  }), _c("div", {
    staticClass: "tiny-crop__dialog-cropper"
  }, [_c("img", {
    ref: "cropImage",
    attrs: {
      "src": _vm.state.src,
      "id": "crops",
      "alt": _vm.state.alt
    }
  })]), _c("div", {
    staticClass: "tiny-crop__dialog-content__handle"
  }, [_c("div", {
    staticClass: "tiny-crop__dialog-content__handle__button"
  }, _vm._l(_vm.state.renderIcon, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "iconButton",
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return item.method($event);
        }
      }
    }, [_c(item.icon, {
      tag: "component",
      staticClass: "iconButtonset"
    })], 1);
  }), 0)]), _c("div", {
    staticClass: "tiny-crop__dialog-content"
  }, [_c("div", {
    staticClass: "tiny-crop__dialog-content__crop"
  }, [_vm.state.cropImg ? _c("img", {
    attrs: {
      "src": _vm.state.cropImg,
      "alt": "post-crop"
    }
  }) : _c("h1", [_vm._v(" " + _vm._s(_vm.t("ui.crop.croppedImage")) + " ")])])])])])]);
};
var staticRenderFns = [function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "croppreviewb"
  }, [_c("div", {
    staticClass: "croppreview"
  })]);
}, function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "croppreviewm"
  }, [_c("div", {
    staticClass: "croppreview"
  })]);
}, function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "croppreviews"
  }, [_c("div", {
    staticClass: "croppreview"
  })]);
}];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Crop = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
Crop.install = function(Vue) {
  Vue.component(Crop.name, Crop);
};
Crop.version = version;
export {
  Crop as default
};
